package cost.speed;

public class Cast {

	static final int COUNT = 100 * 10000;

	public static void main(String[] args) {
		Object cst = new Cast();
		Object obj = new Object();

		double sum = 0;
		for (int i = 0; i < 10; i++) {
			sum += castOnly(cst, 100);
			// sum += instanceof_cast(cst, 100);
			// sum += cast_catch(cst, 100);

			// ~ sum += castOnly(obj, 100);
			// sum += instanceof_cast(obj, 100);
			// sum += cast_catch(obj, 0.1);
		}
		System.out.println(sum / 10);
	}

	static double castOnly(Object obj, int DIV) {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * DIV; i++) {
			Cast c = (Cast) obj;
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("cast:" + e / (double) DIV);
		return e / (double) DIV;
	}

	static double instanceof_cast(Object obj, int DIV) {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * DIV; i++) {
			if (obj instanceof Cast) {
				Cast c = (Cast) obj;
			}
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("cast:" + e / (double) DIV);
		return e / (double) DIV;
	}

	static double cast_catch(Object obj, double DIV) {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * DIV; i++) {
			try {
				Cast c = (Cast) obj;
			} catch (ClassCastException e) {
			}
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("cast:" + e / (double) DIV);
		return e / (double) DIV;
	}
}
