package cost.speed;

public class Syncronized {

	static final int COUNT = 100 * 10000;

	public static void main(String[] args) {
		double sum = 0;
		for (int i = 0; i < 10; i++) {
			sum += nop();
			// sum += _synchronized();
		}
		System.out.println(sum / 10);
	}

	static double nop() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * 1000; i++) {
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("nop:" + e / 1000.0);
		return e / 1000.0;
	}

	static double _synchronized() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * 10; i++) {
			synchronized (Syncronized.class) {
			}
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("sync:" + e / 10.0);
		return e / 10.0;
	}
}
