package cost.speed;

public class Throw {

	public static void main(String[] args) {
		double sum = 0;
		for (int i = 0; i < 10; i++) {
			// _new();
			// _throw_new();
			sum += _throw();

			System.gc();
			try {
				Thread.sleep(20);
			} catch (InterruptedException e) {
			}
		}
		System.out.println(sum / 10.0);
	}

	static void _new() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < 10 * 10000; i++) {
			// new RuntimeException();
			// new Exception();
			// new Throwable();
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("new:" + e);
	}

	static void _throw_new() {
		long s = System.currentTimeMillis();
		for (int i = 0; i < 10 * 10000; i++) {
			try {
				throw new RuntimeException();
			} catch (Exception e) {
			}
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("catch:" + e);
	}

	static double _throw() {
		Exception t = new RuntimeException();
		long s = System.currentTimeMillis();
		for (int i = 0; i < 100 * 10000; i++) {
			try {
				throw t;
			} catch (Exception e) {
			}
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("catch:" + e);
		return e;
	}

}
